Index: branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zfechem.F90
===================================================================
--- branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zfechem.F90	(revision 3777)
+++ branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zfechem.F90	(revision 3780)
@@ -252,5 +252,5 @@
                ! ---------------------------------------------------------
                zdenom1 = xlam1 * trn(ji,jj,jk,jppoc) / zlam1b
-#if  defined key_kriest
+#if ! defined key_kriest
                zdenom2 = xlam1 * trn(ji,jj,jk,jpgoc) / zlam1b
 #endif
Index: branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsms.F90
===================================================================
--- branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsms.F90	(revision 3777)
+++ branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsms.F90	(revision 3780)
@@ -373,26 +373,28 @@
 
       IF( ln_check_mass .AND. kt == nitend ) THEN      !   Compute the budget of NO3, ALK, Si, Fer
-         no3budget = glob_sum( (    trn(:,:,:,jpno3) + trn(:,:,:,jpnh4)  &
-            &                     + trn(:,:,:,jpphy) + trn(:,:,:,jpdia)  &
-            &                     + trn(:,:,:,jpzoo) + trn(:,:,:,jpmes)  &
+         no3budget = glob_sum( (   trn(:,:,:,jpno3) + trn(:,:,:,jpnh4)  &
+            &                    + trn(:,:,:,jpphy) + trn(:,:,:,jpdia)  &
+            &                    + trn(:,:,:,jpzoo) + trn(:,:,:,jpmes)  &
+            &                    + trn(:,:,:,jppoc)                     &
 #if ! defined key_kriest
-            &                     + trn(:,:,:,jppoc) + trn(:,:,:,jpgoc)  &
-#else
-            &                     + trn(:,:,:,jppoc)                     &
+            &                    + trn(:,:,:,jpgoc)                     &
 #endif
-            &                     + trn(:,:,:,jpdoc)                     ) * cvol(:,:,:)  ) 
+            &                    + trn(:,:,:,jpdoc)                     ) * cvol(:,:,:)  ) 
          ! 
          silbudget = glob_sum( (   trn(:,:,:,jpsil) + trn(:,:,:,jpgsi)  &
-            &                     + trn(:,:,:,jpdsi)                     ) * cvol(:,:,:)  )
+            &                    + trn(:,:,:,jpdsi)                     ) * cvol(:,:,:)  )
          ! 
          alkbudget = glob_sum( (   trn(:,:,:,jpno3) * rno3              &
-            &                     + trn(:,:,:,jptal)                     &
-            &                     + trn(:,:,:,jpcal) * 2.                ) * cvol(:,:,:)  )
+            &                    + trn(:,:,:,jptal)                     &
+            &                    + trn(:,:,:,jpcal) * 2.                ) * cvol(:,:,:)  )
          ! 
          ferbudget = glob_sum( (   trn(:,:,:,jpfer) + trn(:,:,:,jpnfe)  &
-            &                     + trn(:,:,:,jpdfe) + trn(:,:,:,jpbfe)  &
-            &                     + trn(:,:,:,jpsfe)                    &
-            &                     + trn(:,:,:,jpzoo)                     &
-            &                     + trn(:,:,:,jpmes) * ferat3            ) * cvol(:,:,:)  )
+            &                    + trn(:,:,:,jpdfe)                     &
+#if ! defined key_kriest
+            &                    + trn(:,:,:,jpbfe)                     &
+#endif
+            &                    + trn(:,:,:,jpsfe)                     &
+            &                    + trn(:,:,:,jpzoo)                     &
+            &                    + trn(:,:,:,jpmes) * ferat3            ) * cvol(:,:,:)  )
 
          !
Index: branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/PISCES/sms_pisces.F90
===================================================================
--- branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/PISCES/sms_pisces.F90	(revision 3777)
+++ branches/2012/dev_MERGE_2012/NEMOGCM/NEMO/TOP_SRC/PISCES/sms_pisces.F90	(revision 3780)
@@ -104,8 +104,9 @@
 #if defined key_kriest
    !!*  Kriest parameter for aggregation
-   REAL(wp) ::   xkr_eta                            !: ???
-   REAL(wp) ::   xkr_zeta                           !: ???
-   REAL(wp) ::   xkr_massp                          !: ???
-   REAL(wp) ::   xkr_mass_min, xkr_mass_max         !: ???
+   REAL(wp) ::   xkr_eta                            !: Sinking  exponent 
+   REAL(wp) ::   xkr_zeta                           !:  N content exponent 
+   REAL(wp) ::   xkr_ncontent                       !:  N content factor   
+   REAL(wp) ::   xkr_massp                          !: 
+   REAL(wp) ::   xkr_mass_min, xkr_mass_max         !:  Minimum, Maximum mass for Aggregates 
 #endif
 