Index: branches/2012/dev_v3_4_STABLE_2012/NEMOGCM/NEMO/NST_SRC/agrif_opa_sponge.F90
===================================================================
--- branches/2012/dev_v3_4_STABLE_2012/NEMOGCM/NEMO/NST_SRC/agrif_opa_sponge.F90	(revision 3917)
+++ branches/2012/dev_v3_4_STABLE_2012/NEMOGCM/NEMO/NST_SRC/agrif_opa_sponge.F90	(revision 3919)
@@ -35,10 +35,10 @@
       REAL(wp), POINTER, DIMENSION(:,:    ) :: localviscsponge
       REAL(wp), POINTER, DIMENSION(:,:    ) :: ztu, ztv
-      REAL(wp), POINTER, DIMENSION(:,:,:,:) :: ztab4d
+      REAL(wp), POINTER, DIMENSION(:,:,:,:) :: ztab
       REAL(wp), POINTER, DIMENSION(:,:,:,:) :: tsbdiff
 
 #if defined SPONGE
       CALL wrk_alloc( jpi, jpj, localviscsponge, ztu, ztv )
-      CALL wrk_alloc( jpi, jpj, jpk, jpts, ztab4d, tsbdiff  )
+      CALL wrk_alloc( jpi, jpj, jpk, jpts, ztab, tsbdiff  )
 
       timecoeff = REAL(Agrif_NbStepint(),wp)/Agrif_rhot()
@@ -46,9 +46,9 @@
       Agrif_SpecialValue=0.
       Agrif_UseSpecialValue = .TRUE.
-      ztab4d = 0.e0
-      CALL Agrif_Bc_Variable(ztab4d, tsa_id,calledweight=timecoeff,procname=interptsn)
+      ztab = 0.e0
+      CALL Agrif_Bc_Variable(ztab, tsa_id,calledweight=timecoeff,procname=interptsn)
       Agrif_UseSpecialValue = .FALSE.
 
-      tsbdiff(:,:,:,:) = tsb(:,:,:,:) - ztab4d(:,:,:,:)
+      tsbdiff(:,:,:,:) = tsb(:,:,:,:) - ztab(:,:,:,:)
 
       spongearea = 2 + 2 * Agrif_irhox()
@@ -148,5 +148,5 @@
 
       CALL wrk_dealloc( jpi, jpj, localviscsponge, ztu, ztv )
-      CALL wrk_dealloc( jpi, jpj, jpk, jpts, ztab4d, tsbdiff  )
+      CALL wrk_dealloc( jpi, jpj, jpk, jpts, ztab, tsbdiff  )
 #endif
 
@@ -166,9 +166,9 @@
       REAL(wp), POINTER, DIMENSION(:,:,:) :: ubdiff, vbdiff
       REAL(wp), POINTER, DIMENSION(:,:,:) :: rotdiff, hdivdiff
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: ztab3d
+      REAL(wp), POINTER, DIMENSION(:,:,:) :: ztab
 
 #if defined SPONGE
       CALL wrk_alloc( jpi, jpj, localviscsponge )
-      CALL wrk_alloc( jpi, jpj, jpk, ztab3d, ubdiff, vbdiff, rotdiff, hdivdiff )
+      CALL wrk_alloc( jpi, jpj, jpk, ztab, ubdiff, vbdiff, rotdiff, hdivdiff )
 
       timecoeff = REAL(Agrif_NbStepint(),wp)/Agrif_rhot()
@@ -176,17 +176,17 @@
       Agrif_SpecialValue=0.
       Agrif_UseSpecialValue = ln_spc_dyn
-      ztab3d = 0.e0
-      CALL Agrif_Bc_Variable(ztab3d, ua_id,calledweight=timecoeff,procname=interpun)
+      ztab = 0.e0
+      CALL Agrif_Bc_Variable(ztab, ua_id,calledweight=timecoeff,procname=interpun)
       Agrif_UseSpecialValue = .FALSE.
 
-      ubdiff(:,:,:) = (ub(:,:,:) - ztab3d(:,:,:))*umask(:,:,:)
-
-      ztab3d = 0.e0
+      ubdiff(:,:,:) = (ub(:,:,:) - ztab(:,:,:))*umask(:,:,:)
+
+      ztab = 0.e0
       Agrif_SpecialValue=0.
       Agrif_UseSpecialValue = ln_spc_dyn
-      CALL Agrif_Bc_Variable(ztab3d, va_id,calledweight=timecoeff,procname=interpvn)
+      CALL Agrif_Bc_Variable(ztab, va_id,calledweight=timecoeff,procname=interpvn)
       Agrif_UseSpecialValue = .FALSE.
 
-      vbdiff(:,:,:) = (vb(:,:,:) - ztab3d(:,:,:))*vmask(:,:,:)
+      vbdiff(:,:,:) = (vb(:,:,:) - ztab(:,:,:))*vmask(:,:,:)
 
       spongearea = 2 + 2 * Agrif_irhox()
@@ -318,5 +318,5 @@
       !                                                ! ===============
       CALL wrk_dealloc( jpi, jpj, localviscsponge )
-      CALL wrk_dealloc( jpi, jpj, jpk, ztab3d, ubdiff, vbdiff, rotdiff, hdivdiff )
+      CALL wrk_dealloc( jpi, jpj, jpk, ztab, ubdiff, vbdiff, rotdiff, hdivdiff )
 
 #endif
Index: branches/2012/dev_v3_4_STABLE_2012/NEMOGCM/NEMO/NST_SRC/agrif_opa_update.F90
===================================================================
--- branches/2012/dev_v3_4_STABLE_2012/NEMOGCM/NEMO/NST_SRC/agrif_opa_update.F90	(revision 3917)
+++ branches/2012/dev_v3_4_STABLE_2012/NEMOGCM/NEMO/NST_SRC/agrif_opa_update.F90	(revision 3919)
@@ -32,10 +32,10 @@
       !!
       INTEGER, INTENT(in) :: kt
-      REAL(wp), POINTER, DIMENSION(:,:,:,:) :: ztab4d
+      REAL(wp), POINTER, DIMENSION(:,:,:,:) :: ztab
 
        
       IF((Agrif_NbStepint() .NE. (Agrif_irhot()-1)).AND.(kt /= 0)) RETURN
 #if defined TWO_WAY
-      CALL wrk_alloc( jpi, jpj, jpk, jpts, ztab4d )
+      CALL wrk_alloc( jpi, jpj, jpk, jpts, ztab )
 
       Agrif_UseSpecialValueInUpdate = .TRUE.
@@ -43,12 +43,12 @@
 
       IF (MOD(nbcline,nbclineupdate) == 0) THEN
-         CALL Agrif_Update_Variable(ztab4d,tsn_id, procname=updateTS)
-      ELSE
-         CALL Agrif_Update_Variable(ztab4d,tsn_id,locupdate=(/0,2/), procname=updateTS)
+         CALL Agrif_Update_Variable(ztab,tsn_id, procname=updateTS)
+      ELSE
+         CALL Agrif_Update_Variable(ztab,tsn_id,locupdate=(/0,2/), procname=updateTS)
       ENDIF
 
       Agrif_UseSpecialValueInUpdate = .FALSE.
 
-      CALL wrk_dealloc( jpi, jpj, jpk, jpts, ztab4d )
+      CALL wrk_dealloc( jpi, jpj, jpk, jpts, ztab )
 #endif
 
@@ -62,5 +62,5 @@
       INTEGER, INTENT(in) :: kt
       REAL(wp), POINTER, DIMENSION(:,:) :: ztab2d
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: ztab3d
+      REAL(wp), POINTER, DIMENSION(:,:,:) :: ztab
 
 
@@ -68,12 +68,12 @@
 #if defined TWO_WAY
       CALL wrk_alloc( jpi, jpj,      ztab2d )
-      CALL wrk_alloc( jpi, jpj, jpk, ztab3d )
+      CALL wrk_alloc( jpi, jpj, jpk, ztab   )
 
       IF (mod(nbcline,nbclineupdate) == 0) THEN
-         CALL Agrif_Update_Variable(ztab3d,un_id,procname = updateU)
-         CALL Agrif_Update_Variable(ztab3d,vn_id,procname = updateV)
-      ELSE
-         CALL Agrif_Update_Variable(ztab3d,un_id,locupdate=(/0,1/),procname = updateU)
-         CALL Agrif_Update_Variable(ztab3d,vn_id,locupdate=(/0,1/),procname = updateV)         
+         CALL Agrif_Update_Variable(ztab,un_id,procname = updateU)
+         CALL Agrif_Update_Variable(ztab,vn_id,procname = updateV)
+      ELSE
+         CALL Agrif_Update_Variable(ztab,un_id,locupdate=(/0,1/),procname = updateU)
+         CALL Agrif_Update_Variable(ztab,vn_id,locupdate=(/0,1/),procname = updateV)         
       ENDIF
 
@@ -89,5 +89,5 @@
 
       CALL wrk_dealloc( jpi, jpj,      ztab2d )
-      CALL wrk_dealloc( jpi, jpj, jpk, ztab3d )
+      CALL wrk_dealloc( jpi, jpj, jpk, ztab   )
 
 !Done in step
Index: branches/2012/dev_v3_4_STABLE_2012/NEMOGCM/NEMO/NST_SRC/agrif_top_sponge.F90
===================================================================
--- branches/2012/dev_v3_4_STABLE_2012/NEMOGCM/NEMO/NST_SRC/agrif_top_sponge.F90	(revision 3917)
+++ branches/2012/dev_v3_4_STABLE_2012/NEMOGCM/NEMO/NST_SRC/agrif_top_sponge.F90	(revision 3919)
@@ -36,9 +36,9 @@
       REAL(wp) :: ztra, zabe1, zabe2, zbtr
       REAL(wp), POINTER, DIMENSION(:,:) :: localviscsponge
-      REAL(wp), POINTER, DIMENSION(:,:,:,:) :: trbdiff, ztru, ztrv, ztab4d
+      REAL(wp), POINTER, DIMENSION(:,:,:,:) :: trbdiff, ztru, ztrv, ztab
 
 #if defined SPONGE_TOP
       CALL wrk_alloc( jpi, jpj, localviscsponge )
-      CALL wrk_alloc( jpi, jpj, jpk, jptra, trbdiff, ztru, ztrv, ztab4d )
+      CALL wrk_alloc( jpi, jpj, jpk, jptra, trbdiff, ztru, ztrv, ztab )
 
       timecoeff = REAL(Agrif_NbStepint(),wp)/Agrif_rhot()
@@ -46,9 +46,9 @@
       Agrif_SpecialValue=0.
       Agrif_UseSpecialValue = .TRUE.
-      ztab4d = 0.e0
-      CALL Agrif_Bc_Variable(ztab4d, tra_id,calledweight=timecoeff,procname=interptrn)
+      ztab = 0.e0
+      CALL Agrif_Bc_Variable(ztab, tra_id,calledweight=timecoeff,procname=interptrn)
       Agrif_UseSpecialValue = .FALSE.
 
-      trbdiff(:,:,:,:) = trb(:,:,:,:) - ztab4d(:,:,:,:)
+      trbdiff(:,:,:,:) = trb(:,:,:,:) - ztab(:,:,:,:)
 
       spongearea = 2 + 2 * Agrif_irhox()
@@ -147,5 +147,5 @@
  
       CALL wrk_dealloc( jpi, jpj, localviscsponge )
-      CALL wrk_dealloc( jpi, jpj, jpk, jptra, trbdiff, ztru, ztrv, ztab4d )
+      CALL wrk_dealloc( jpi, jpj, jpk, jptra, trbdiff, ztru, ztrv, ztab )
 
 #endif
Index: branches/2012/dev_v3_4_STABLE_2012/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90
===================================================================
--- branches/2012/dev_v3_4_STABLE_2012/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90	(revision 3917)
+++ branches/2012/dev_v3_4_STABLE_2012/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90	(revision 3919)
@@ -159,16 +159,16 @@
 
    ! Arrays used in mpp_lbc_north_3d()
-   REAL(wp), DIMENSION(:,:,:)  , ALLOCATABLE, SAVE   ::   ztab, znorthloc
-   REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE, SAVE   ::   znorthgloio
-   REAL(wp), DIMENSION(:,:,:)  , ALLOCATABLE, SAVE   ::   zfoldwk      ! Workspace for message transfers avoiding mpi_allgather
+   REAL(wp), DIMENSION(:,:,:)  , ALLOCATABLE, SAVE   ::   tab_3d, xnorthloc
+   REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE, SAVE   ::   xnorthgloio
+   REAL(wp), DIMENSION(:,:,:)  , ALLOCATABLE, SAVE   ::   foldwk      ! Workspace for message transfers avoiding mpi_allgather
 
    ! Arrays used in mpp_lbc_north_2d()
-   REAL(wp), DIMENSION(:,:)  , ALLOCATABLE, SAVE    ::   ztab_2d, znorthloc_2d
-   REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, SAVE    ::   znorthgloio_2d
-   REAL(wp), DIMENSION(:,:)  , ALLOCATABLE, SAVE    ::   zfoldwk_2d    ! Workspace for message transfers avoiding mpi_allgather
+   REAL(wp), DIMENSION(:,:)  , ALLOCATABLE, SAVE    ::   tab_2d, xnorthloc_2d
+   REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, SAVE    ::   xnorthgloio_2d
+   REAL(wp), DIMENSION(:,:)  , ALLOCATABLE, SAVE    ::   foldwk_2d    ! Workspace for message transfers avoiding mpi_allgather
 
    ! Arrays used in mpp_lbc_north_e()
-   REAL(wp), DIMENSION(:,:)  , ALLOCATABLE, SAVE    ::   ztab_e, znorthloc_e
-   REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, SAVE    ::   znorthgloio_e
+   REAL(wp), DIMENSION(:,:)  , ALLOCATABLE, SAVE    ::   tab_e, xnorthloc_e
+   REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, SAVE    ::   xnorthgloio_e
 
    ! North fold arrays used to minimise the use of allgather operations. Set in nemo_northcomms (nemogcm) so need to be public
@@ -209,11 +209,11 @@
          &      tr2we(1-jpr2dj:jpj+jpr2dj,jpreci+jpr2di,2) ,                                                     &
          !
-         &      ztab(jpiglo,4,jpk) , znorthloc(jpi,4,jpk) , znorthgloio(jpi,4,jpk,jpni) ,                        &
-         &      zfoldwk(jpi,4,jpk) ,                                                                             &
-         !
-         &      ztab_2d(jpiglo,4)  , znorthloc_2d(jpi,4)  , znorthgloio_2d(jpi,4,jpni)  ,                        &
-         &      zfoldwk_2d(jpi,4)  ,                                                                             &
-         !
-         &      ztab_e(jpiglo,4+2*jpr2dj) , znorthloc_e(jpi,4+2*jpr2dj) , znorthgloio_e(jpi,4+2*jpr2dj,jpni) ,   &
+         &      tab_3d(jpiglo,4,jpk) , xnorthloc(jpi,4,jpk) , xnorthgloio(jpi,4,jpk,jpni) ,                        &
+         &      foldwk(jpi,4,jpk) ,                                                                             &
+         !
+         &      tab_2d(jpiglo,4)  , xnorthloc_2d(jpi,4)  , xnorthgloio_2d(jpi,4,jpni)  ,                        &
+         &      foldwk_2d(jpi,4)  ,                                                                             &
+         !
+         &      tab_e(jpiglo,4+2*jpr2dj) , xnorthloc_e(jpi,4+2*jpr2dj) , xnorthgloio_e(jpi,4+2*jpr2dj,jpni) ,   &
          !
          &      STAT=lib_mpp_alloc )
@@ -2229,12 +2229,12 @@
       ityp = -1
       ijpjm1 = 3
-      ztab(:,:,:) = 0.e0
-      !
-      DO jj = nlcj - ijpj +1, nlcj          ! put in znorthloc the last 4 jlines of pt3d
+      tab_3d(:,:,:) = 0.e0
+      !
+      DO jj = nlcj - ijpj +1, nlcj          ! put in xnorthloc the last 4 jlines of pt3d
          ij = jj - nlcj + ijpj
-         znorthloc(:,ij,:) = pt3d(:,jj,:)
+         xnorthloc(:,ij,:) = pt3d(:,jj,:)
       END DO
       !
-      !                                     ! Build in procs of ncomm_north the znorthgloio
+      !                                     ! Build in procs of ncomm_north the xnorthgloio
       itaille = jpi * jpk * ijpj
       IF ( l_north_nogather ) THEN
@@ -2246,5 +2246,5 @@
             ij = jj - nlcj + ijpj
             DO ji = 1, nlci
-               ztab(ji+nimpp-1,ij,:) = pt3d(ji,jj,:)
+               tab_3d(ji+nimpp-1,ij,:) = pt3d(ji,jj,:)
             END DO
          END DO
@@ -2271,8 +2271,8 @@
 
             DO jr = 1,nsndto(ityp)
-               CALL mppsend(5, znorthloc, itaille, isendto(jr,ityp), ml_req_nf(jr) )
+               CALL mppsend(5, xnorthloc, itaille, isendto(jr,ityp), ml_req_nf(jr) )
             END DO
             DO jr = 1,nsndto(ityp)
-               CALL mpprecv(5, zfoldwk, itaille, isendto(jr,ityp))
+               CALL mpprecv(5, foldwk, itaille, isendto(jr,ityp))
                iproc = isendto(jr,ityp) + 1
                ildi = nldit (iproc)
@@ -2281,5 +2281,5 @@
                DO jj = 1, ijpj
                   DO ji = ildi, ilei
-                     ztab(ji+iilb-1,jj,:) = zfoldwk(ji,jj,:)
+                     tab_3d(ji+iilb-1,jj,:) = foldwk(ji,jj,:)
                   END DO
                END DO
@@ -2296,6 +2296,6 @@
 
       IF ( ityp .lt. 0 ) THEN
-         CALL MPI_ALLGATHER( znorthloc  , itaille, MPI_DOUBLE_PRECISION,                &
-            &                znorthgloio, itaille, MPI_DOUBLE_PRECISION, ncomm_north, ierr )
+         CALL MPI_ALLGATHER( xnorthloc  , itaille, MPI_DOUBLE_PRECISION,                &
+            &                xnorthgloio, itaille, MPI_DOUBLE_PRECISION, ncomm_north, ierr )
          !
          DO jr = 1, ndim_rank_north         ! recover the global north array
@@ -2306,5 +2306,5 @@
             DO jj = 1, ijpj
                DO ji = ildi, ilei
-                  ztab(ji+iilb-1,jj,:) = znorthgloio(ji,jj,:,jr)
+                  tab_3d(ji+iilb-1,jj,:) = xnorthgloio(ji,jj,:,jr)
                END DO
             END DO
@@ -2312,5 +2312,5 @@
       ENDIF
       !
-      ! The ztab array has been either:
+      ! The tab_3d array has been either:
       !  a. Fully populated by the mpi_allgather operation or
       !  b. Had the active points for this domain and northern neighbours populated
@@ -2319,10 +2319,10 @@
       ! this domain will be identical.
       !
-      CALL lbc_nfd( ztab, cd_type, psgn )   ! North fold boundary condition
+      CALL lbc_nfd( tab_3d, cd_type, psgn )   ! North fold boundary condition
       !
       DO jj = nlcj-ijpj+1, nlcj             ! Scatter back to pt3d
          ij = jj - nlcj + ijpj
          DO ji= 1, nlci
-            pt3d(ji,jj,:) = ztab(ji+nimpp-1,ij,:)
+            pt3d(ji,jj,:) = tab_3d(ji+nimpp-1,ij,:)
          END DO
       END DO
@@ -2361,12 +2361,12 @@
       ityp = -1
       ijpjm1 = 3
-      ztab_2d(:,:) = 0.e0
-      !
-      DO jj = nlcj-ijpj+1, nlcj             ! put in znorthloc_2d the last 4 jlines of pt2d
+      tab_2d(:,:) = 0.e0
+      !
+      DO jj = nlcj-ijpj+1, nlcj             ! put in xnorthloc_2d the last 4 jlines of pt2d
          ij = jj - nlcj + ijpj
-         znorthloc_2d(:,ij) = pt2d(:,jj)
+         xnorthloc_2d(:,ij) = pt2d(:,jj)
       END DO
 
-      !                                     ! Build in procs of ncomm_north the znorthgloio_2d
+      !                                     ! Build in procs of ncomm_north the xnorthgloio_2d
       itaille = jpi * ijpj
       IF ( l_north_nogather ) THEN
@@ -2378,5 +2378,5 @@
             ij = jj - nlcj + ijpj
             DO ji = 1, nlci
-               ztab_2d(ji+nimpp-1,ij) = pt2d(ji,jj)
+               tab_2d(ji+nimpp-1,ij) = pt2d(ji,jj)
             END DO
          END DO
@@ -2404,8 +2404,8 @@
 
             DO jr = 1,nsndto(ityp)
-               CALL mppsend(5, znorthloc_2d, itaille, isendto(jr,ityp), ml_req_nf(jr) )
+               CALL mppsend(5, xnorthloc_2d, itaille, isendto(jr,ityp), ml_req_nf(jr) )
             END DO
             DO jr = 1,nsndto(ityp)
-               CALL mpprecv(5, zfoldwk_2d, itaille, isendto(jr,ityp))
+               CALL mpprecv(5, foldwk_2d, itaille, isendto(jr,ityp))
                iproc = isendto(jr,ityp) + 1
                ildi = nldit (iproc)
@@ -2414,5 +2414,5 @@
                DO jj = 1, ijpj
                   DO ji = ildi, ilei
-                     ztab_2d(ji+iilb-1,jj) = zfoldwk_2d(ji,jj)
+                     tab_2d(ji+iilb-1,jj) = foldwk_2d(ji,jj)
                   END DO
                END DO
@@ -2429,6 +2429,6 @@
 
       IF ( ityp .lt. 0 ) THEN
-         CALL MPI_ALLGATHER( znorthloc_2d  , itaille, MPI_DOUBLE_PRECISION,        &
-            &                znorthgloio_2d, itaille, MPI_DOUBLE_PRECISION, ncomm_north, ierr )
+         CALL MPI_ALLGATHER( xnorthloc_2d  , itaille, MPI_DOUBLE_PRECISION,        &
+            &                xnorthgloio_2d, itaille, MPI_DOUBLE_PRECISION, ncomm_north, ierr )
          !
          DO jr = 1, ndim_rank_north            ! recover the global north array
@@ -2439,5 +2439,5 @@
             DO jj = 1, ijpj
                DO ji = ildi, ilei
-                  ztab_2d(ji+iilb-1,jj) = znorthgloio_2d(ji,jj,jr)
+                  tab_2d(ji+iilb-1,jj) = xnorthgloio_2d(ji,jj,jr)
                END DO
             END DO
@@ -2445,5 +2445,5 @@
       ENDIF
       !
-      ! The ztab array has been either:
+      ! The tab array has been either:
       !  a. Fully populated by the mpi_allgather operation or
       !  b. Had the active points for this domain and northern neighbours populated
@@ -2452,5 +2452,5 @@
       ! this domain will be identical.
       !
-      CALL lbc_nfd( ztab_2d, cd_type, psgn )   ! North fold boundary condition
+      CALL lbc_nfd( tab_2d, cd_type, psgn )   ! North fold boundary condition
       !
       !
@@ -2458,5 +2458,5 @@
          ij = jj - nlcj + ijpj
          DO ji = 1, nlci
-            pt2d(ji,jj) = ztab_2d(ji+nimpp-1,ij)
+            pt2d(ji,jj) = tab_2d(ji+nimpp-1,ij)
          END DO
       END DO
@@ -2491,18 +2491,18 @@
       !
       ijpj=4
-      ztab_e(:,:) = 0.e0
+      tab_e(:,:) = 0.e0
 
       ij=0
-      ! put in znorthloc_e the last 4 jlines of pt2d
+      ! put in xnorthloc_e the last 4 jlines of pt2d
       DO jj = nlcj - ijpj + 1 - jpr2dj, nlcj +jpr2dj
          ij = ij + 1
          DO ji = 1, jpi
-            znorthloc_e(ji,ij)=pt2d(ji,jj)
+            xnorthloc_e(ji,ij)=pt2d(ji,jj)
          END DO
       END DO
       !
       itaille = jpi * ( ijpj + 2 * jpr2dj )
-      CALL MPI_ALLGATHER( znorthloc_e(1,1)  , itaille, MPI_DOUBLE_PRECISION,    &
-         &                znorthgloio_e(1,1,1), itaille, MPI_DOUBLE_PRECISION, ncomm_north, ierr )
+      CALL MPI_ALLGATHER( xnorthloc_e(1,1)  , itaille, MPI_DOUBLE_PRECISION,    &
+         &                xnorthgloio_e(1,1,1), itaille, MPI_DOUBLE_PRECISION, ncomm_north, ierr )
       !
       DO jr = 1, ndim_rank_north            ! recover the global north array
@@ -2513,5 +2513,5 @@
          DO jj = 1, ijpj+2*jpr2dj
             DO ji = ildi, ilei
-               ztab_e(ji+iilb-1,jj) = znorthgloio_e(ji,jj,jr)
+               tab_e(ji+iilb-1,jj) = xnorthgloio_e(ji,jj,jr)
             END DO
          END DO
@@ -2521,5 +2521,5 @@
       ! 2. North-Fold boundary conditions
       ! ----------------------------------
-      CALL lbc_nfd( ztab_e(:,:), cd_type, psgn, pr2dj = jpr2dj )
+      CALL lbc_nfd( tab_e(:,:), cd_type, psgn, pr2dj = jpr2dj )
 
       ij = jpr2dj
@@ -2528,5 +2528,5 @@
       ij  = ij +1
          DO ji= 1, nlci
-            pt2d(ji,jj) = ztab_e(ji+nimpp-1,ij)
+            pt2d(ji,jj) = tab_e(ji+nimpp-1,ij)
          END DO
       END DO